<?php
/**
 * Implements admim forms.
 */
function scald_wysiwyg_contexts_admin_form($form, &$form_state) {
    foreach (scald_types() as $scald) {
        $contexts = array();
        foreach (scald_contexts_public() as $id => $context) {
            if ($scald->type == 'image') {
                $image_styles = array_keys(image_styles());
                array_walk($image_styles, function(&$v, $k) {$v = 'style-'.$v;});
                if (isset($context['transcoder']['image']['*']) && in_array($context['transcoder']['image']['*'], $image_styles)) {
                    if ($context['provider'] == 'scald') {
                        $contexts[$id] = t($context['title']);
                    }
                }
            } else {
                $contexts[$id] = t($context['title']);
            }
        }

        $form['scald_wysiwyg_contexts_allowed_contexts_' . $scald->type] =  array(
            '#title' => t('Allowed ' . $scald->type . ' contexts'),
            '#type' => 'checkboxes',
            '#options' => $contexts,
            '#default_value' => variable_get('scald_wysiwyg_contexts_allowed_contexts_' . $scald->type, array()),
            '#required' => FALSE,
        );
    }

    return system_settings_form($form);
}
